dnl Autoconf extension macros
dnl c1996 Andrew Veliath
dnl $Id: aclocal.m4,v 0.2 1996/01/11 22:57:46 drewvel Exp $

dnl -------------------
AC_DEFUN(AV_CHECK_CXXSTRING,
[AC_MSG_CHECKING([for ANSI C++ string type])
AC_CACHE_VAL(av_cv_have_cxxstring,[
AC_LANG_SAVE
AC_LANG_CPLUSPLUS
AC_TRY_COMPILE([
#include <string>
string a="test";
],,
av_cv_have_cxxstring=yes,
av_cv_have_cxxstring=no)])
AC_LANG_RESTORE
if test "$av_cv_have_cxxstring" = "yes"; then
AC_MSG_RESULT(yes)
AC_DEFINE(HAVE_CXXSTRING)
else
AC_MSG_RESULT(no)
fi])

dnl -------------------
AC_DEFUN(AV_CHECK_STL,
[AC_MSG_CHECKING([for working Standard Template Library])
AC_CACHE_VAL(av_cv_have_stl,[
AC_LANG_SAVE
AC_LANG_CPLUSPLUS
AC_TRY_COMPILE([
#include <algo.h>
#include <iterator.h>
#include <vector.h>
#include <map.h>
#include <multimap.h>
#include <set.h>
#include <multiset.h>
class Class { public: int a; };
vector<Class> v;
map<int, float, less<int> > m;
multimap<int, float, less<int> > mm;
],,
av_cv_have_stl=yes,
av_cv_have_stl=no)])
AC_LANG_RESTORE
if test "$av_cv_have_stl" = "yes"; then
AC_MSG_RESULT(yes)
AC_DEFINE(HAVE_STL)
else
AC_MSG_RESULT(no)
fi])

dnl -------------------
AC_DEFUN(AV_EXPLICIT_ANSI_TEMPLATES,
[AC_MSG_CHECKING([for ANSI C++ explicit template instantiation])
AC_CACHE_VAL(av_cv_explicit_ansi_templates,[
AC_LANG_SAVE
AC_LANG_CPLUSPLUS
AC_TRY_COMPILE([
template <class T> class TClass { public: T value; };
template class TClass<char>;
],,
av_cv_explicit_ansi_templates=yes,
av_cv_explicit_ansi_templates=no)])
AC_LANG_RESTORE
if test "$av_cv_explicit_ansi_templates" = "yes"; then
AC_MSG_RESULT(yes)
AC_DEFINE(HAVE_EXPLICIT_ANSI_TEMPLATES)
else
AC_MSG_RESULT(no)
fi])

AC_SUBST(FFLAGS)

dnl -------------------
dnl AC_PROG_F77()
AC_DEFUN(AC_PROG_F77,[AC_CHECK_PROGS(FC,f77 g77 fort77)])

dnl -------------------
dnl AC_LANG_F77()
AC_DEFUN(AC_LANG_F77,
[define([AC_LANG], [F77])dnl
ac_ext=f
ac_compile='echo ${FC} -c $FFLAGS conftest.$ac_ext 1>&AC_FD_CC;
${FC} -c $FFLAGS conftest.$ac_ext 1>&AC_FD_CC 2>&AC_FD_CC'
ac_link='echo ${FC} -o conftest $FFLAGS $LDFLAGS conftest.$ac_ext $LIBS 1>&AC_FD_CC;
${FC} -o conftest $FFLAGS $LDFLAGS conftest.$ac_ext $LIBS 1>&AC_FD_CC 2>&AC_FD_CC'
])


dnl -------------------
AC_DEFUN(AV_TRY_CF77LINK,[
dnl check for unchanged
if test -z "$av_cv_cf77link"; then
dnl call the Fortran stub from C++
rm -f conftest.$ac_ext; cat > conftest.$ac_ext <<EOF
extern void $1(); int main() { $1(); return 0; }
EOF
if ! eval $ac_compile; then
	AC_MSG_ERROR([couldn't run ${CC-cc} (see config.log)])
fi
if eval 'echo ${CC-cc} $LDFLAGS -o conftest conftest.o conftest2.o $LIBS 1>&AC_FD_CC; ${CC-cc} $LDFLAGS -o conftest conftest.o conftest2.o $LIBS 1>&AC_FD_CC 2>&AC_FD_CC'; then
	av_cv_cf77link=$2
fi; fi
])

dnl -------------------
AC_DEFUN(AV_FUNC_CF77LINK,
[
AC_MSG_CHECKING([how to call Fortran from C/C++])
AC_CACHE_VAL(av_cv_cf77link,
[
AC_LANG_SAVE

AC_LANG_F77
dnl compile Fortran stub
cat > conftest.$ac_ext <<EOF
      SUBROUTINE TF77
      RETURN
      END
EOF
if ! eval $ac_compile; then
	AC_MSG_ERROR([couldn't run $FC (see config.log)])
fi
mv conftest.o conftest2.o

AC_LANG_C

if test -z "$av_cv_cf77link"; then
AV_TRY_CF77LINK(tf77,unchanged)
fi
if test -z "$av_cv_cf77link"; then
AV_TRY_CF77LINK(_tf77,prefix_)
fi
if test -z "$av_cv_cf77link"; then
AV_TRY_CF77LINK(tf77_,suffix_)
fi

rm -rf conftest*
AC_LANG_RESTORE
])dnl
case "$av_cv_cf77link" in
	unchanged) 
	AC_MSG_RESULT([unchanged])
	AC_DEFINE(CF77_UNCHANGED)
	;;
	prefix_)
	AC_MSG_RESULT([prefix underscore])
	AC_DEFINE(CF77_PREFIX_)
	;;
	suffix_)
	AC_MSG_RESULT([suffix underscore])
	AC_DEFINE(CF77_SUFFIX_)
	;;
	*) AC_MSG_WARN([unknown method]) ;;
esac
])
