/***************************************************************************

    analyzer.h                          

    Copyright (C) 1996 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: analyzer.h,v 0.17 1996/02/17 06:54:58 drewvel Exp $ */

#ifndef __ANALYZER_H
#define __ANALYZER_H

/*******************************************************************/
#include "gconfig.h"

#define LINE_METHOD 1
#define SEGS_METHOD 2
#define SOLID_BARS_METHOD 3
#define SEG_BARS_METHOD 4
#define DEFAULT_METHOD LINE_METHOD
#define METHOD_COUNT 4

class ostream;

/*******************************************************************/
class TAnalyzer {
private:
  bool ProcessArgs(int, char *[], globalConfig&);
  void ProgramInfo();
  void Usage();

protected:
  const globalConfig& gconfig_default;
  globalConfig gconfig;  
  void gConfigDiff(const globalConfig&, const globalConfig&, 
		   ostream& out) const;

public:
  TAnalyzer(int&, char *[], const globalConfig&);
};


/*******************************************************************/
#endif /* __ANALYZER_H */
