/***************************************************************************

    svga_analyzer.h                                                       

    Copyright (C) 1995 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

// $Id: svga_analyzer.h,v 0.18 1996/02/17 07:00:17 drewvel Exp $             

#ifndef __SVGA_ANALYZER_H
#define __SVGA_ANALYZER_H

#include <string>

#include "../analyzer.h"
#include "../common.h"
#include "../vox_signal.h"

#define ENDMESSAGE "<click!>"


/*******************************************************************/
class TSVGA_Analyzer:public TAnalyzer {

friend class TSVGA_Display;

private:
  void init();

  int displayType, windowSize;
  
  void NewDisplay(int);
  void DeleteDisplay();

protected:

  TVox_Signal signal;
  string fname;

  TSVGA_Display* display;
  
  TBuffer<TSignal::sample8> buffer8, avg8;
  TBuffer<TSignal::sample16> buffer16, avg16;

  bool done;

  int CurrentMethod(int type=0);

  bool ProcessKeys();

  void AutoCalibrate();
  void UpdateFrequencies();
  void WriteOptions(const char *) const;

  int WindowSize() const;
  int WindowSize(int);

  void OnUpdateSignalParameters();

  void OnSetConfig(const globalConfig&);
  void OnRetrieveConfig(globalConfig&) const;
    
public:
  TSVGA_Analyzer(globalConfig&, int&, char *[]);
  ~TSVGA_Analyzer();
  
  void Initiate();
};


/*******************************************************************/
#endif /* __SVGA_ANALYZER_H */
