/***************************************************************************

    svga_colors.C

    Copyright (C) 1995 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

// $Id: svga_color.C,v 1.1 1996/02/17 07:00:17 drewvel Exp $

/**************************************************************************/
#include <vgagl.h>

#include "svga_color.h"

/**************************************************************************/
int
SVGA_RGBColor(const TColor& c)
{
  return gl_rgbcolor(c.r, c.g, c.b);
}


/**************************************************************************/
void 
SVGA_FadeArray(const TColor& C1, const TColor& C2, int TColors[], int len)
{
  if (len!=0) {
    if (len>255) len=255;
    TColor Inc=(C2-C1)/len;    
    TColor Mid=C1;

    for (int i=0; i<len; i++) {
      TColors[i]=SVGA_RGBColor(Mid);
      Mid=Mid+Inc;
    }    
  }
}


/**************************************************************************/
void 
SVGA_FadeColorRange(const TColor colsin[], int numcols, int colsout[], int len)
{
  numcols--;
  float divlen=(float) len/(float) numcols;
  for (int i=0; i<numcols; i++) 
    SVGA_FadeArray(colsin[i], colsin[i+1], 
		   colsout+(int) ((float) i*divlen), 
		   (int) divlen);
  colsout[len]=SVGA_RGBColor(colsin[numcols]);
}


/**************************************************************************/
