/**************************************************************************

    gconfig.h

    Copyright (C) 1996 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: gconfig.h,v 1.20 1996/02/17 06:55:33 drewvel Exp $ */

#ifndef __GCONFIG_H
#define __GCONFIG_H
/*******************************************************************/

struct StrOption {
  char val[32];
  char name[256];
};

struct IntOption {
  int val;
  char name[32];
};

struct RealOption {
  float val;
  char name[32];
};

struct BoolOption {
  bool val;
  char name[32];
};

class TColor;

struct ColorOption {
  int r; 
  int g; 
  int b;
  char name[32];

  bool operator == (const ColorOption&) const;
  bool operator != (const ColorOption&) const;
  ColorOption& operator = (const ColorOption&);
  ColorOption& operator = (const TColor&);
};


struct globalConfig {

  StrOption Device;
#define NUMSTROPTIONS 1

  IntOption SampleRate;
  IntOption SampleSize;
  IntOption VPos;
  IntOption Method;

  IntOption LowFreq;
  IntOption HighFreq;
  IntOption RangeInc;
  IntOption NumBands;

  IntOption SegWidth;
  IntOption SegHeight;
  IntOption SegSpace;
  IntOption MedSegVal;

  IntOption HiSegVal;
  IntOption Offset8;
  IntOption Offset16;
#define NUMINTOPTIONS 15

  RealOption Attenuation;
  RealOption AvgAmt;
#define NUMREALOPTIONS 2

  ColorOption FG;
  ColorOption BG;
  ColorOption GraphBG;
  ColorOption LabelColor;

  ColorOption AxesColor;
  ColorOption LineColor;
  ColorOption LowSegColor;
  ColorOption MedSegColor;

  ColorOption HiSegColor;
  ColorOption PeakColor;
#define NUMCOLOROPTIONS 10

  BoolOption Run;
  BoolOption Bits8;
  BoolOption Averaging;
  BoolOption LogScale;
  BoolOption LogFreqScale;
  BoolOption MaxBands;
  BoolOption NoText;
#define NUMBOOLOPTIONS 7
};

/*******************************************************************/
#endif /* __GCONFIG_H */
