/**************************************************************************

    method.h

    Copyright (C) 1996 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: method.h,v 0.5 1996/02/08 05:57:56 drewvel Exp $ */

#ifndef __METHOD_H
#define __METHOD_H

/*******************************************************************/
#include "fft/ftypes.h"
#include "display.h"
#include "controls.h"

struct globalConfig;

class TMethod;

/*******************************************************************/
class TMethodControls { 
private:
  const TMethod& method;
  
public:
  TMethodControls(const TMethod&);

  real attenuation;
  IntControl vposition;
  BoolControl LogY;  
};


/*******************************************************************/
TMethodControls& operator << (TMethodControls&, const globalConfig&);
const TMethodControls& operator >> (const TMethodControls&, globalConfig&);


/*******************************************************************/
class TMethod:virtual public TDisplay {

friend class TDMStatus;
friend class TMethodControls;

protected:  

  TMethodControls mc;

  // text status update
  void MethodStatus(vector<string>&) const;

  // messages
  void OnUpdate();

  int ProcessMethodControl(char);

  // global configuration accessors
  void OnSetMethodConfig(const globalConfig&);
  void OnRetrieveMethodConfig(globalConfig&);

public:
  TMethod();
};


/*******************************************************************/
#endif /* __METHOD_H */
