/**************************************************************************

    line_method.C

    Copyright (C) 1995-96 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: line_method.C,v 0.4 1996/02/17 07:00:36 drewvel Exp $ */

/*******************************************************************/
#include "../rms.h"
#include "line_method.h"

/*******************************************************************/
TLine_Method::TLine_Method()
{
  DEBUG("TLine_Method constructing width==" << di.width);
}


/*******************************************************************/
void
TLine_Method::OnResizeMethod()
{
  TMethod_2D::OnResizeMethod();

  DEBUG("TLine_Method_2D OnResizeMethod");

  save_data.length(band_base.length());

  for (register int i=0; i<save_data.length(); save_data[i++]=y_offset);
}


/*******************************************************************/
bool
TLine_Method::OnStartMethod()
{
  for (register int i=0; i<save_data.length(); save_data[i++]=y_offset);
  return true;
}


/*******************************************************************/
void
TLine_Method::OnUpdate()
{  
  float intv=(float) x_left_offset;
  int x1, y1, x2, y2, save_y1, save_y2, max=save_data.length();
 
  // initialize previous point
  x1=x_left_offset;
  Y_Position(0, y1);
  y1=y_offset-y1;
  save_y1=save_data[0];
  
  for (register int i=1; i<max; i++) {

    // calculate new point    
    intv+=interval;
    x2=(int) intv;
    Y_Position(i, y2);
    y2=y_offset-y2; // flip

    save_y2=save_data[i];

    if (save_y1 != y1 || save_y2 != y2) { 
      
      DrawLine(x1, save_y1, x2, save_y2, di.bg);
      DrawLine(x1, y1, x2, y2, di.linecolor);
      
      save_data[i-1]=y1;
    }

    x1=x2; y1=y2; save_y1=save_y2;
  }

  save_data[max-1]=y1;
}


/*******************************************************************/
int
TLine_Method::QueryFrequencyFromPoint(int x, int)
{
  if (x>x_left_offset && x<(di.width-x_right_offset))
    return 
      frequencies.index()[band_base.index()[(int) ((float) (x-x_left_offset+1)/interval)]];
  else 
    return -1;
}


/*******************************************************************/
int
TLine_Method::QueryAmplitudeFromPoint(int x, int)
{
  if (x>x_left_offset && x<(di.width-x_right_offset))
    return Amplitude(save_data[(int) ((float) (x-x_left_offset+1)/interval)]);
  else
    return -1;
}


/*******************************************************************/
