/**************************************************************************

    segs_method.h

    Copyright (C) 1995 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: segs_method.h,v 0.4 1996/02/08 05:57:38 drewvel Exp $ */

#ifndef __SEGS_METHOD_H
#define __SEGS_METHOD_H

/*******************************************************************/
#include "../method_2d.h"
#include "../buffer.h"


class TSegs_Method;

/*******************************************************************/
class TSegs_MethodControls {
private:
  const TSegs_Method& method;

public:

  TSegs_MethodControls(const TSegs_Method&);

  int divider;

  IntControl segHeight;
  IntControl segWidth;
  IntControl holdCountMax;
  BoolControl peaks;
  BoolControl falling;
};


/*******************************************************************/
TSegs_MethodControls& operator << (TSegs_MethodControls&, const globalConfig&);
const TSegs_MethodControls& operator >> (const TSegs_MethodControls&, globalConfig&);


/*******************************************************************/
class TSegs_Method:public TMethod_2D {

  friend class TSegs_MethodControls;

protected:  

  struct TSeg {
    int value, peak;
  };

  TSegs_MethodControls smc;

  int holdCount;
  int bar_y_offset, bar_x_left_offset;
  float bar_interval;
  TBuffer<TSeg> bar;

  // events
  void OnResizeMethod();
  bool OnStartMethod();
  void OnUpdate();    

  // global configuration accessors
  void OnSetMethodConfig(const globalConfig&);
  void OnRetrieveMethodConfig(globalConfig&);

public:
  TSegs_Method();
};


/*******************************************************************/
#endif /* __SEGS_METHOD_H */
