/**************************************************************************

    signal.C

    Copyright (C) 1996 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: signal.C,v 0.14 1996/02/17 06:59:39 drewvel Exp $ */

/*******************************************************************/
#include "signal.h"
#include "common.h"


/*******************************************************************/
void
TSignal::init()
{
  isOpen=false;
  sig=0;  
}


/*******************************************************************/
TSignal::TSignal()
{
  init();
  DEBUG("TSignal constructed");
}


/*******************************************************************/
TSignal::~TSignal()
{
  close();
  DEBUG("TSignal destroyed");
}


/*******************************************************************/
bool
TSignal::open(const string& name)
{
  DEBUG("TSignal open " << name);

  isOpen=true;

  sig=::open(name.c_str(), O_RDONLY);
  
  if (sig<0) 
    isOpen=false;
  else {
    DEBUG(" -- signal opened, calling OnOpen");
    isOpen=isOpen && OnOpen();
    
    if (!isOpen) ::close(sig);
  }
  
  if (isOpen) 
    filename=name;

  return isOpen;
}


/*******************************************************************/
void
TSignal::close()
{
  if (open()) { 
    ::close(sig);
    isOpen=false;
  }
  DEBUG("TSignal close");
}


/*******************************************************************/
bool
TSignal::OnOpen()
{
  DEBUG("TSignal event OnOpen");
  return true;
}

/*******************************************************************/
