/**************************************************************************

    vox_signal.h   

    Copyright (C) 1995 Andrew Veliath

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


***************************************************************************/

/* $Id: vox_signal.h,v 0.4 1996/02/17 06:55:33 drewvel Exp $ */

#ifndef __VOX_SIGNAL_H
#define __VOX_SIGNAL_H

/*******************************************************************/
#include "signal.h"


/*******************************************************************/
class TVox_Signal:public TSignal {

private:

  void init();

protected:

  // messages
  bool OnOpen();

public:
  TVox_Signal();

  int ioctl(int, int parm=0) const;
  void flush();

  int bits() const;
  int bits(int);
  int sample_rate() const;
  int sample_rate(int);
  int channels() const;
  int channels(int);
  int calibrate8(int n=numcalsamples);
  int calibrate16(int n=numcalsamples);
};


/*******************************************************************/
inline int
TVox_Signal::ioctl(int call, int parm) const
{
  ::ioctl(*this, call, &parm);
  return parm;
}


/*******************************************************************/
#endif /* __VOX_SIGNAL_H */
